
set list_TestRun [glob -nocomplain -types f "Data/TestRun/TestWare/*/Runs/*/*"]
Log "Load all TestRuns and save them"

foreach elm $list_TestRun {
	set path [string map {"Data/TestRun/" ""} $elm]
	Log "Load and save $path"
	
	LoadTestRun $path
	SaveTestRun $path
}

Log "Finished loading and saving the TestRuns"
Log ""

set list_TestRun_Result [glob -nocomplain -types f "Data/TestRun/TestWare/*/Runs/Results"]
Log "Load all Result TestRuns and save them"

foreach elm $list_TestRun_Result {
	set path [string map {"Data/TestRun/" ""} $elm]
	Log "Load and save $path"
	
	LoadTestRun $path
	SaveTestRun $path
}

Log "Finished loading and saving the Result TestRuns"
Log ""

set list_TestSeries [glob -nocomplain -types f "Data/TestRun/TestWare/*/*.ts"]
Log "Load all TestSeries and save them"

foreach elm $list_TestSeries {
	set path [string map {"Data/TestRun/" ""} $elm]
	Log "Load and save $path"
	
	TestMgr load $path
	TestMgr save $path
}

Log "Finished loading and saving the TestSeries"
Log ""

set list_TestCatalog [glob -nocomplain -types f "Data/TestRun/TestWare/*/*.tws"]
Log "Load all Test Catalogs and save them"

TestMgr::Popup -twdesigner

foreach elm $list_TestCatalog {
	set path [string map {"Data/TestRun/" ""} $elm]
	Log "Load and save $path"
	
	TestMgr::Load $path
	TestMgr::Save $path
}

TestMgr::Close

Log "Finished loading and saving the Test Catalogs"
Log ""

set list_Vehicle [glob -nocomplain -types f "Data/Vehicle/*"]
Log "Load all Vehicle Infofiles and save them"

foreach elm $list_Vehicle {
	set path [string map {"Data/Vehicle/" ""} $elm]
	Log "Load and save $path"
	
	Car::Load $path
	Car::Save $path
	Car::Close $path
}
Log "Finished loading and saving the Vehicle Infofiles"
Log ""

set list_Road [glob -nocomplain -types f "Data/Road/*/*"]
Log "Load all .rd5 files and save them"

foreach elm $list_Road {
	set path [string map {"Data/Road/" ""} $elm]
	Log "Load and save $path"
	
	Scene::File_Read $path
	Scene::Save $path
}
Log "Finished loading and saving the .rd5 files"