### Namespace ALKS ###
namespace eval ::ALKS {

### StartProcACC ###
proc StartProcALKS {key name args} {
    switch $key {
	TestSeries {
	    
	    if {[SignalMapping]} { TestMgr::Stop }
	    set ::TS::ALKS_ON(Car) 1
	}
	Group {
	    #RefScoreACC
	}
	TestRunGroup {
		GetSystem ALKS
		if {$name eq "TestWare/ALKS/Runs/Results"} {
			return
		}

		if {$::TS::ALKS == 0} {
			ScriptControl::Popup
			Log "\nError - ALKS System DEACTIVATED\n"
			::TestMgr::SkipToEnd Group
			return
		}
	}
	TestRun {
			
	    if {[KeyValue exists TestRun:Vehicle]} {
	 	set ::TS::VehicleName [KeyValue get TestRun:Vehicle]
	    } else {
		# use Vehicle linked with TestRun
		set path2TestRun Data/TestRun/$name
		set ::TS::VehicleName [IFileRead $path2TestRun Vehicle]
	    }
	
	    set path2Vehicle Data/Vehicle/$::TS::VehicleName
	
	    GetVehicleLength $name
	    GetVehicleWidth $name
	    
	    set trafficWidth [GetTrafficWidth $name]
	    NamedValue set TrafficWidth $trafficWidth
	

	    if {[string match "*LaneKeeping_leading_GVT" $name]} {

		set ::TS::Tst LaneKeeping

		#The minimum following distance shall be calculated using the formula: dmin  = vALKS* tfront
		set t_front [ expr {1+[NamedValue get v_vut]*0.01 }]
		NamedValue set d_min [expr {[NamedValue get v_vut]/3.6* $t_front}]

		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
			NamedValue set MotionKind "4Wheel"
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

			NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
			NamedValue set BasicsDimension_length  2.000 
			NamedValue set BasicsDimension_width 0.6
			NamedValue set BasicsDimension_height	1.3					
			NamedValue set Info "leading PTW" 
			NamedValue set MotionKind 2Wheel					
		}
		NamedValue set v_GVT [NamedValue get v_vut]
	    }

	    if {[string match "*LaneKeeping_swerving_GVT" $name]} {

		set ::TS::Tst LaneKeeping_swerving
		
		set t_front [ expr {1+[NamedValue get v_vut]*0.01 }]
		NamedValue set d_min [expr { [NamedValue get v_vut]/3.6* $t_front  }]
			    
		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
			NamedValue set MotionKind "4Wheel"
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

			NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
			NamedValue set BasicsDimension_length  2.000 
			NamedValue set BasicsDimension_width 0.6
			NamedValue set BasicsDimension_height	1.3					
			NamedValue set Info "leading PTW" 
			NamedValue set MotionKind 2Wheel
			NamedValue set CenterOfMass 1.0
			NamedValue set MotionKind "2Wheel"
			NamedValue set Motionmass 300.0
		}
		NamedValue set v_GVT [NamedValue get v_vut]
	    }
	
	    if {[string match "*LaneKeeping_GVT driving close beside" $name]} {

		set ::TS::Tst LaneKeeping_beside

		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
		    NamedValue set MotionKind "4Wheel"
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height	1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind "2Wheel"
		}
		NamedValue set v_GVT [NamedValue get v_vut]
	    }

	    if {[string match "*Stationary_target" $name]} { 
		
		set ::TS::Tst stationary_target
		
		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
		
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
		    NamedValue set MotionKind "4Wheel"	
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height	1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind "2Wheel"
		}
		
		if {[string compare "pedestrian" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/NCAP/Pedestrian_Adult_EuroNCAP_2015_Static.mobj"
		    NamedValue set Info "stationary pedestrian" 
		    NamedValue set BasicsDimension_length  0.6 
		    NamedValue set BasicsDimension_width 0.5
		    NamedValue set BasicsDimension_height	1.8
		    NamedValue set CenterOfMass 0.335
		}

		if {[string compare "target" [NamedValue get Movie_Geometry]]== 0} {
		    
		    NamedValue set MovieGeometry "3D/StreetFurniture/TrafficDrum.mobj"
		    NamedValue set Info "stationary pedestrian" 
		    NamedValue set BasicsDimension_length  0.79 
		    NamedValue set BasicsDimension_width 0.76
		    NamedValue set BasicsDimension_height	1.07
		    NamedValue set CenterOfMass 0.395
		}
	    }

	    if {[string match "*Crossing_pedestrian_left" $name]} { 
		    
		    set ::TS::Tst crossing_pedestrian_left				
		    NamedValue set t_GVT 6.24	
	    }

	    if {[string match "*Crossing_pedestrian_right" $name]} { 
		    
		    set ::TS::Tst crossing_pedestrian_left
		    NamedValue set t_GVT -6.24
	    }	

	    if {[string match "*Multiple_obstacles_blocking_the_lane" $name]} { 
				    
		    set ::TS::Tst multiple_obstacles
				    
	    }
	    
	    if {[string match "*Following_constant_speed_deceleration" $name] || [string match "*Following_varying_speed_deceleration" $name] } {

		if {[string match "*Following_constant_speed_deceleration" $name] } {
		    set ::TS::Tst following
		    set t_front [ expr {1+[NamedValue get v_vut]*0.01 }]
		    NamedValue set d_min [expr { [NamedValue get v_vut]/3.6* $t_front  }]
		}
		
		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			    
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
		    NamedValue set MotionKind "4Wheel"
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height	1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind "2Wheel"
		}
	    }

	    if {[string match "*CutIn" $name]} {

		set ::TS::Tst CutIn
		
		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
		    NamedValue set MotionKind "4Wheel"	
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height	1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind "2Wheel"
		}
	    }
	
	    if {[string match "*CutOut" $name]  } {

		set ::TS::Tst CutOut

		NamedValue set t_Change_CutOut [expr {3.5 / [NamedValue get Vy]}]
		
		
		if {[string compare "car" [NamedValue get Movie_Geometry]]== 0} {
			
		    NamedValue set MovieGeometry "3D/Vehicles/IPG_CompanyCar_2018_Yellow.mobj"
		    NamedValue set Info "leading car" 
		    NamedValue set BasicsDimension_length  4.470 
		    NamedValue set BasicsDimension_width 1.970
		    NamedValue set BasicsDimension_height 1.120
		    NamedValue set CenterOfMass 2.21
		    NamedValue set MotionKind "4Wheel"
		}

		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height	1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind 2Wheel
		}
		
		if {[string compare "pedestrian" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/NCAP/Pedestrian_Adult_EuroNCAP_2015_Static.mobj"
		    NamedValue set Info "stationary pedestrian" 
		    NamedValue set BasicsDimension_length  0.6 
		    NamedValue set BasicsDimension_width 0.5
		    NamedValue set BasicsDimension_height	1.8
		    NamedValue set CenterOfMass 0.335
		}

		if {[string compare "target" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/StreetFurniture/TrafficDrum.mobj"
		    NamedValue set Info "TrafficDrum" 
		    NamedValue set BasicsDimension_length  0.79 
		    NamedValue set BasicsDimension_width 0.76
		    NamedValue set BasicsDimension_height	1.07
		    NamedValue set CenterOfMass 0.395
		}
	    }

	    if {[string match "*FoV_forward" $name]} {
		    
		set ::TS::Tst FoV_forward
		if {[string compare "PTW" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/Vehicles/Honda_CBR600RR_2016_Traffic_Driver.obj"
		    NamedValue set BasicsDimension_length  2.000 
		    NamedValue set BasicsDimension_width 0.6
		    NamedValue set BasicsDimension_height 1.3					
		    NamedValue set Info "leading PTW" 
		    NamedValue set MotionKind 2Wheel
		}
		
		if {[string compare "pedestrian" [NamedValue get Movie_Geometry]]== 0} {

		    NamedValue set MovieGeometry "3D/NCAP/Pedestrian_Adult_EuroNCAP_2015_Static.mobj"
		    NamedValue set Info "stationary pedestrian" 
		    NamedValue set BasicsDimension_length  0.6 
		    NamedValue set BasicsDimension_width 0.5
		    NamedValue set BasicsDimension_height 1.8
		    NamedValue set CenterOfMass 0.335
		}
		
		if {[string compare "ego" [NamedValue get Lane]]== 0} { 
		    NamedValue set Route 1

		} elseif {[string compare "left" [NamedValue get Lane]]== 0} { 
		    NamedValue set Route 0

		} elseif {[string compare "right" [NamedValue get Lane]]== 0} {
		    NamedValue set Route 2
		}
	    }
	    
	    SetStartCondition [NamedValue get v_vut] $name
	}
    }
}

### EndProcALKS ###
proc EndProcALKS {key name args} {
	TestMgr::ClearTS
	switch $key {
		TestSeries {SetResultDate;}
		Group {SetSystem ALKS;}
		TestRunGroup { }
		TestRun {}
	}
}

proc ResultFollowingLeadVehicle {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set THW [ NamedValue get THW]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]

    Log "##### LANE KEEPING #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	Log  "Testrun Following a lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	Log   "Testrun Following a lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	Log   "Testrun Following a lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec\n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	Log   "Testrun Following a lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec\n with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    } 
    
}


proc ResultFollowingSwervingLeadVehicle {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set THW [ NamedValue get THW]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]
    
    Log "##### LANE KEEPING - SWERVING LEAD VEHICLE #####\n"
    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun Following a swerving lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n without errors \n" 

    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun Following a swerving lead  $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun Following a swerving lead $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun Following a swerving lead  $vehicle with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n THW:$THW sec \n with with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
}

proc ResultGVTDrivingColseBeside {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set t_GVT [NamedValue get t_GVT]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]

    Log "##### LANE KEEPING - GVT CLOSE BESIDE #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun $vehicle driving close beside  with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun  $vehicle driving close beside  with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun  $vehicle driving close beside with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n with error OUTOFLANE. with $v_imp kp/h  \n"  
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun  $vehicle driving close beside  with:\n v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n with with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
	
}

proc ResultAvoidCollisionStationaryTarget {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set t_GVT [NamedValue get t_GVT]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]
    set curved  [NamedValue get curved]
    set section "straight"
    set partially "full within the lane"
    if {$curved == 1 && $t_GVT==0} {
	    set section "curved"		
    } elseif {$curved == 1  && $t_GVT != 0} {
	    set section "curved"
	    set partially "partially within the lane"		
    } elseif {$curved == 0  && $t_GVT == 0} {
	    set section "straight"
    } elseif {$curved == 0  && $t_GVT != 0} {
	    set section "straight"
	    set partially "partially within the lane"		
    }
    Log "##### AVOID COLLISION - STATIONARY TARGET #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with target $vehicle $partially at $section section with\n v_vut: $v_vut kph \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with target $vehicle $partially at $section section with\n v_vut: $v_vut kph \n  with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log   "Testrun avoid a collision with target $vehicle $partially at $section section with\n v_vut: $v_vut kph \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with target $vehicle $partially at $section section with\n v_vut: $v_vut kph \n with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    } 
	
}
proc ResultAvoidCollisionCrossingPedestrian_left {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]

    Log "##### AVOID COLLISION - CROSSING PEDESTRIAN FROM LEFT #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from left with \n v_vut: $v_vut kph  \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from left  with\n v_vut: $v_vut kph  \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from left  with\n  v_vut: $v_vut kph \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from left wtih\n v_vut: $v_vut kph  \n with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
	
}

proc ResultAvoidCollisionCrossingPedestrian_right {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]

    Log "##### AVOID COLLISION - CROSSING PEDESTRIAN FROM RIGHT #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from right with \n v_vut: $v_vut kph  \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from right  with\n v_vut: $v_vut kph  \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from right  with\n  v_vut: $v_vut kph \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian from right wtih\n v_vut: $v_vut kph  \n with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
	
}

proc ResultAvoidCollisionCrossingPedestrian_curved {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set vehicle  [NamedValue get Movie_Geometry]

    Log "##### AVOID COLLISION - CROSSING PEDESTRIAN FROM LEFT CURVED SECTION #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian curved section with \n v_vut: $v_vut kph  \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with a crossing pedestrian curved section  with\n v_vut: $v_vut kph  \n with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian curved section  with\n  v_vut: $v_vut kph \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with a crossing pedestrian curved section wtih\n v_vut: $v_vut kph  \n with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    } 
}

proc ResultAvoidCollisionMultipleObstacles {args} {

    set v_vut [NamedValue get v_vut ]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set curved  [NamedValue get curved]
    set section "straight"
    if {$curved == 1} {
	    set section "curved"		
    }

    Log "##### AVOID COLLISION - MULTIPLE OBSTACLES #####\n"
    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with multiple obstacles at $section section with v_vut: $v_vut kph  \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun avoid a collision with multiple obstacles at $section section  with v_vut: $v_vut kph \n  with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with multiple obstacles at $section section  with  v_vut: $v_vut kph \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun avoid a collision with multiple obstacles at $section section  with v_vut: $v_vut kph \n  with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
	
}

proc ResultFollowingConstantSpeed  {args} {
		
    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set a_GVT [NamedValue get a_GVT]
    set t_GVT [NamedValue get t_GVT]
    set THW [NamedValue get TTC]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set curved  [NamedValue get curved]
    set section "straight"
    set partially "that is full within the lane"
    set vehicle  [NamedValue get Movie_Geometry]
     if {$curved == 1 && $t_GVT==0} {
	    set section "curved"		
    } elseif {$curved == 1  && $t_GVT != 0} {
	    set section "curved"
	    set partially "that is partially within the lane"		
    } elseif {$curved == 0  && $t_GVT == 0} {
	    set section "straight"
    } elseif {$curved == 0  && $t_GVT != 0} {
	    set section "straight"
	    set partially "that is partially within the lane"		
    }
Log "##### FOLLOWING GVT WITH CONSTANT SPEED DECELERATION #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun following a $vehicle $partially  with constant speed at $section section with v_vut:$v_vut kph  \n v_GVT:$v_GVT kph  \n a_decel_GVT:$a_GVT m/s^2 \n THW:$THW sec \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun following a $vehicle $partially  constant speed at $section section  with v_vut:$v_vut kph  \n v_GVT:$v_GVT kph \n a_decel_GVT:$a_GVT m/s^2 \n THW:$THW sec \n  with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun following a $vehicle $partially  constant speed at $section section  with  v_vut:$v_vut kph  \n v_GVT:$v_GVT kph \n a_decel_GVT:$a_GVT m/s^2 \n THW:$THW sec \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun following a $vehicle $partially  constant speed at $section section  with v_vut:$v_vut kph  \n v_GVT:$v_GVT kph \n a_decel_GVT:$a_GVT m/s^2 \n THW:$THW sec \n  with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
}

proc ResultFollowingVaryingSpeed  {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set a_GVT [NamedValue get a_GVT]
    set t_GVT [NamedValue get t_GVT]
    set a_decel_GVT  [NamedValue get a_decel_GVT]
    set THW [NamedValue get TTC]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set curved  [NamedValue get curved]
    set section "straight"
    set partially "that is full within the lane"
    set vehicle  [NamedValue get Movie_Geometry]
     if {$curved == 1 && $t_GVT==0} {
	    set section "curved"		
    } elseif {$curved == 1  && $t_GVT != 0} {
	    set section "curved"
	    set partially "that is partially within the lane"		
    } elseif {$curved == 0  && $t_GVT == 0} {
	    set section "straight"
    } elseif {$curved == 0  && $t_GVT != 0} {
	    set section "straight"
	    set partially "that is partially within the lane"		
    }

    Log "##### FOLLOWING GVT WITH VARYING SPEED DECELERATION #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun following a $vehicle $partially with varying speed  at $section section with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph \n a_GVT:$a_GVT m/s^2 \n a_decel_GVT:$a_decel_GVT \n THW:$THW sec \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun following a $vehicle $partially with varying speed  at $section section  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph \n a_GVT:$a_GVT m/s^2 \n a_decel_GVT:$a_decel_GVT \n THW:$THW sec \n  with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun following a $vehicle $partially with varying speed  at $section section  with  v_vut: $v_vut kph  \n v_GVT:$v_GVT kph \n a_GVT:$a_GVT m/s^2 \n a_decel_GVT:$a_decel_GVT \n THW:$THW sec \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun following a $vehicle $partially with varying speed  at $section section  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph \n a_GVT:$a_GVT m/s^2 \n a_decel_GVT:$a_decel_GVT \n THW:$THW sec \n  with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
}

proc ResultCutIn {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_GVT]
    set Vy [NamedValue get Vy]
    set TTC [NamedValue get TTC]
    set t_GVT [NamedValue get t_GVT]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set curved  [NamedValue get curved]
    set section "straight"

    if {$curved == 1} {
	    set section "curved"		
    }

    Log "##### CUT IN #####\n"
    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun CutIn  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW:$TTC sec \n without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun CutIn  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW:$TTC sec \n  with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
    Log  "Testrun CutIn  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW:$TTC sec \n with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
    Log  "Testrun CutIn  with v_vut: $v_vut kph  \n v_GVT:$v_GVT kph  \n leadCar.v_y:$Vy: m/s  \n THW:$TTC sec \n  with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
}

proc ResultCutOut {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_lead]
    set Vy [NamedValue get Vy]
    set TTC  [NamedValue get THW]
    set v_imp [get ALKS.v_imp]
    set v_red [get ALKS.v_red]
    set impact [get ALKS.impact]
    set OutOfLane [get ALKS.OutOfLane]
    set dx0_f [NamedValue get dx0_f]
    set curved  [NamedValue get curved]
    set section "straight"
    if {$curved == 1} {
	    set section "curved"		
    }
    Log "##### CUT OUT #####\n"

    if {$impact == 0 && $OutOfLane == 0} {
	    Log  "Testrun CutOut with v_vut: $v_vut kph \n v_GVT:$v_GVT kph \n leadCar.v_y: $Vy: m/s  \n THW: $TTC sec \n dx0_f: $dx0_f  without errors \n" 
    }  elseif  {$impact == 1 && $OutOfLane == 0} {
	    Log  "Testrun CutOut with v_vut: $v_vut kph \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW: $TTC sec \n dx0_f: $dx0_f   with error IMPACT. with $v_imp kp/h  \n" 
    }  elseif  {$impact == 0 && $OutOfLane == 1} {
	    Log  "Testrun CutOut   with v_vut: $v_vut kph \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW: $TTC sec \n dx0_f: $dx0_f  with error OUTOFLANE. with $v_imp kp/h  \n" 
    } elseif  {$impact == 1 && $OutOfLane == 1} {
	    Log  "Testrun CutOut  with v_vut: $v_vut kph \n v_GVT:$v_GVT kph  \n leadCar.v_y: $Vy: m/s  \n THW: $TTC sec \n dx0_f: $dx0_f  with error IMPACT and OUTOFLANE. with $v_imp kp/h  \n" 
    }
}

proc ResultFoVLat {args} {

    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_lead]
    set ALKS_relvTgt_ds_x  [expr {double(round(100*[get ALKS_relvTgt_ds_x]))/100}]
    set ALKS_relvTgt_ds_y   [expr {double(round(100*[ get ALKS_relvTgt_ds_y ]))/100}]
    set ALKS_relvTgt_ds_p   [expr {double(round(100*[ get ALKS_relvTgt_ds_p]))/100}]
    set Route [NamedValue get Route]

    Log "##### TEST OF THE LATERAL DETECTION RANGE #####\n"
    if {$Route == 0} {
    set lane left 
    } elseif {$Route==2} {
    set lane right
    }

    if {$ALKS_relvTgt_ds_x == 0 && $ALKS_relvTgt_ds_y == 0 && $ALKS_relvTgt_ds_p == 0} {
	    Log  " FAILURE: NO DETECTION \n" 
    }  elseif {$ALKS_relvTgt_ds_x != 0 || $ALKS_relvTgt_ds_y != 0 || $ALKS_relvTgt_ds_p != 0} {
	    Log  "Target on $lane lane detected:\n Relative distance to the target in LATERAL-direction: $ALKS_relvTgt_ds_y  \n Relative distance to the target in Longitudinal-direction: $ALKS_relvTgt_ds_x  \n Relative distance to the target: $ALKS_relvTgt_ds_p  \n" 
    }
}

proc ResultFoVForward {args} {
	
    set v_vut [NamedValue get v_vut ]
    set v_GVT [NamedValue get v_lead]
    set ALKS_relvTgt_ds_x  [expr {double(round(100*[get ALKS_relvTgt_ds_x]))/100}]
    set ALKS_relvTgt_ds_y   [expr {double(round(100*[ get ALKS_relvTgt_ds_y ]))/100}]
    set ALKS_relvTgt_ds_p   [expr {double(round(100*[ get ALKS_relvTgt_ds_p]))/100}]
    set Route [NamedValue get Route]

    Log "##### TEST OF THE LONGITUDINAL DETECTION RANGE #####\n"

    if {$Route == 0} {
    set lane left 
    } elseif {$Route==2} {
    set lane right
    } elseif {$Route==1} {
    set lane ego
    }

    if {$ALKS_relvTgt_ds_x == 0 && $ALKS_relvTgt_ds_y == 0 && $ALKS_relvTgt_ds_y == 0} {
	    Log  " FAILURE: NO DETECTION \n" 
    }  elseif {$ALKS_relvTgt_ds_x != 0 || $ALKS_relvTgt_ds_y != 0 || $ALKS_relvTgt_ds_y != 0} {
	    Log  "Target on $lane lane detected:\n Relative distance to the target in lateral direction: $ALKS_relvTgt_ds_y  \n Relative distance to the target in longitudinal direction: $ALKS_relvTgt_ds_x  \n Relative distance to the target: $ALKS_relvTgt_ds_p  \n" 
    }
}
}