### Namespace ELKS ###
namespace eval ::ELKS {

### StartProcELKS ###
proc StartProcELKS {key name args} {

	switch $key {
		TestSeries {
			if {[SignalMapping]} { TestMgr::Stop }
			GetVehicleLength
			GetVehicleWidth
			CompareResultDate

		}
	Group {
	}
	TestRunGroup {
		GetSystem ELKS
		if {$::TS::ELKS == 0} {
			ScriptControl::Popup
			Log "\nError - ELKS System DEACTIVATED\n"
			::TestMgr::SkipToEnd Group
			return
		}
	}
		TestRun {
			set PathRadius 1200
			NamedValue set LaneWidth 3.7

			if {[KeyValue exists TestRun:Vehicle]} {
				set ::TS::VehicleName [KeyValue get TestRun:Vehicle]
			} else {
				# use Vehicle linked with TestRun
				set path2TestRun Data/TestRun/$name
				set ::TS::VehicleName [IFileRead $path2TestRun Vehicle]
			}
			if {$name eq "TestWare/ELKS/Runs/ELKS_LDW" || $name eq "TestWare/ELKS/Runs/ELKS_CDCF"} {
				if {[NamedValue get DepartureSideNo] == -1} {
					# Leaving on right side
					set ::TS::ELKS_DTLE_LDW -0.3
					set ::TS::ELKS_DTLE -0.3
					set ::TS::ELKS_DTLE_CDCF -0.3
					# Solid line on the right side
					NamedValue set LineWidthR 0.125
					NamedValue set LineWidth [NamedValue get LineWidthR]
					NamedValue set LineTypeR 1
					NamedValue set DetectionProbabilityR 1
					# Dashed line on the left side
					NamedValue set LineWidthL 0.15
					NamedValue set SpaceLengthL 4
					NamedValue set DashLengthL 2
					NamedValue set DetectionProbabilityL 1
					NamedValue set LineTypeL 2
					# Path calculation 
					### Calculate and setup lateral vehicle position depending on Vlat
					set LateralDistance [GetLatDist $PathRadius]
					set LateralDeviation [GetLatDev $PathRadius]
					set YawAngle [GetYawAngle]
					set d [expr $LateralDistance + $LateralDeviation + [NamedValue get VehicleWidth]/2]
					NamedValue set LatOffset [expr ([NamedValue get LaneWidth] - [NamedValue get LineWidthR]/2 - $d) * -1]
					NamedValue set LatOffsetD1 [expr ([NamedValue get LaneWidth] - [NamedValue get LineWidthR]/2 - $d + $LateralDeviation) * -1]
					NamedValue set LatOffsetD2 [expr ([NamedValue get LaneWidth] - [NamedValue get LineWidthR]/2 - $d + $LateralDeviation + $LateralDistance) * -1]
					NamedValue set LongBegin 710
					NamedValue set LongRadius [expr [NamedValue get LongBegin] + $PathRadius * $YawAngle]
					NamedValue set DeviationAng [expr -1* $YawAngle]
					NamedValue set DeviationAngInv [expr $YawAngle]
					NamedValue set LongEnd [expr [NamedValue get LongRadius] + ($LateralDistance/tan($YawAngle))]
					NamedValue set LateralVelocity [expr -1* [NamedValue get LateralVelocity]]
					NamedValue set LongEndOfPath [expr [NamedValue get LongEnd] + (2/tan($YawAngle))]
					NamedValue set LongEndOfPathExt [expr [NamedValue get LongEndOfPath] + 1]
					NamedValue set LatOffsetEnd [expr ([NamedValue get LaneWidth] - [NamedValue get LineWidthR]/2 - $d + $LateralDeviation + $LateralDistance + 2) * -1]
				} elseif {[NamedValue get DepartureSideNo] == 1} {
					### Leaving on left side
					set ::TS::ELKS_DTLE -0.3
					set ::TS::ELKS_DTLE_LDW -0.3
					set ::TS::ELKS_DTLE_CDCF -0.3
					# Solid line on the left side
					NamedValue set LineWidthL 0.125
					NamedValue set LineWidth [NamedValue get LineWidthL]
					NamedValue set LineTypeL 1
					NamedValue set DetectionProbabilityL 1
					# Dashed line on the right side
					NamedValue set LineWidthR 0.15
					NamedValue set SpaceLengthR 4
					NamedValue set DashLengthR 2
					NamedValue set DetectionProbabilityR 1
					NamedValue set LineTypeR 2					
					# Path calculation 
					### Calculate and setup lateral vehicle position depending on Vlat
					set LateralDistance [GetLatDist $PathRadius]
					set LateralDeviation [GetLatDev $PathRadius]
					set YawAngle [GetYawAngle]
					set d [expr $LateralDistance + $LateralDeviation + [NamedValue get VehicleWidth]/2]
					NamedValue set LatOffset [expr ($d + [NamedValue get LineWidthL]/2) * -1]
					NamedValue set LatOffsetD1 [expr ($d + [NamedValue get LineWidthL]/2 - $LateralDeviation) * -1]
					NamedValue set LatOffsetD2 [expr ($d + [NamedValue get LineWidthL]/2 - $LateralDeviation - $LateralDistance) * -1]
					NamedValue set LongBegin 710
					NamedValue set LongRadius [expr [NamedValue get LongBegin] + $PathRadius * $YawAngle]
					NamedValue set DeviationAng [expr $YawAngle]
					NamedValue set LongEnd [expr [NamedValue get LongRadius] + ($LateralDistance/tan($YawAngle))]
					NamedValue set LateralVelocity [expr [NamedValue get LateralVelocity]]
					NamedValue set LongEndOfPath [expr [NamedValue get LongEnd] + (2/tan($YawAngle))]
					NamedValue set LatOffsetEnd [expr ($d + [NamedValue get LineWidthL]/2 - $LateralDeviation - $LateralDistance - 2) * -1]
				}
			} elseif {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI_3_interv" || $name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI10s"} {
				if {[NamedValue get DepartureSideNo] >= 0} {
					# Leaving on left side
					if {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI_3_interv"} {
						NamedValue set LatOff_Car 2
					} elseif {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI10s"} {
						NamedValue set LatOff_Car 1
					}
					# Solid line on the left side
					NamedValue set LineWidthL 0.125
					NamedValue set LineWidth [NamedValue get LineWidthL]
					NamedValue set LineTypeL 1
					NamedValue set DetectionProbabilityL 1
					# Dashed line on the right side
					NamedValue set LineWidthR 0.15
					NamedValue set SpaceLengthR 4
					NamedValue set DashLengthR 2
					NamedValue set DetectionProbabilityR 1
					NamedValue set LineTypeR 2
				} elseif {[NamedValue get DepartureSideNo] < 0} {
					# Leaving on right side
					if {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI_3_interv" } {
						NamedValue set LatOff_Car -2
					} elseif {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_WI10s"} {
						NamedValue set LatOff_Car -1
					}
					# Solid line on the right side
					NamedValue set LineWidthR 0.125
					NamedValue set LineWidth [NamedValue get LineWidthR]
					NamedValue set LineTypeR 1
					NamedValue set DetectionProbabilityR 1
					# Dashed line on the left side
					NamedValue set LineWidthL 0.15
					NamedValue set SpaceLengthL 4
					NamedValue set DashLengthL 2
					NamedValue set DetectionProbabilityL 1
					NamedValue set LineTypeL 2
				}
			} elseif {$name eq "TestWare/ELKS/Runs/ELKS_CDCF_Steering_Override"} {
					if {[NamedValue get DepartureSideNo] < 0 } {
						NamedValue set LatOff_Car -2
					} elseif {[NamedValue get DepartureSideNo] > 0} {
						NamedValue set LatOff_Car 2
					} 
				# Solid line on the left side
				NamedValue set LineWidthL 0.125
				NamedValue set LineWidth [NamedValue get LineWidthL]
				NamedValue set LineTypeL 1
				NamedValue set DetectionProbabilityL 1
				# Solid line on the right side
				NamedValue set LineWidthR 0.125
				NamedValue set LineWidth [NamedValue get LineWidthR]
				NamedValue set LineTypeR 1
				NamedValue set DetectionProbabilityR 1
			}
			# Set Quant Audits
			QuantAudit del all
		}
	}
}


### EndProcELKS ###
proc EndProcELKS {key name args} {
	TestMgr::ClearTS
	switch $key {
		TestSeries		{ SetResultDate;}
		Group			{ SetSystem ELKS;}
		TestRunGroup		{ }
		TestRun			{ }
	}
		
	if {[string match "*PreTest" $name]} {
		SaveMode collect
	}
}


proc ResultMixedLaneDepatureSide {args} {

    set v_vut [NamedValue get v_vut ]
	set DepartureSideNo [NamedValue get DepartureSideNo]
	set LateralVelocity [NamedValue get LateralVelocity]
    set ELKS_On [get ELKS.On]
	set ELKS_DTLE_LDW [get ELKS.DTLE_LDW]
	set ELKS_MaxDev_vx [get ELKS.MaxDev_vx]
	set ELKS_MaxDev_vlat [get ELKS.MaxDev_vlat]
	
    Log "##### LDW: MIXED LANE DEPATURE SIDE #####\n"

    if {$ELKS_On == 1 && $ELKS_DTLE_LDW >= $::TS::ELKS_DTLE_LDW && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 3.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n v_vut:$v_vut kph \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n without errors \n" 
    }  elseif {$ELKS_On == 1 && $ELKS_DTLE_LDW < $::TS::ELKS_DTLE_LDW && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 3.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n v_vut:$v_vut kph \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n with error: MAXIMUM DTLE EXCEEDEDED with ELKS_DTLE_LDW = $ELKS_DTLE_LDW m > $::TS::ELKS_DTLE_LDW m\n" 
    } elseif {$ELKS_On != 1 && $ELKS_DTLE_LDW >= $::TS::ELKS_DTLE_LDW && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 3.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n v_vut:$v_vut kph \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n with error: ELKS not activated \n"  
    } elseif {$ELKS_On != 1 && $ELKS_DTLE_LDW < $::TS::ELKS_DTLE_LDW && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 3.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n v_vut:$v_vut kph \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph \n with error: ELKS not activated and MAXIMUM DTLE EXCEEDEDED\n"  
    } elseif {$ELKS_On == 1 && $ELKS_DTLE_LDW >= $::TS::ELKS_DTLE_LDW || $ELKS_MaxDev_vlat > 0.05 || $ELKS_MaxDev_vx > 3.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n v_vut:$v_vut kph \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph \n with error:\n ELKS_MaxDev_vlat with ELKS_MaxDev_vlat = $ELKS_MaxDev_vlat kph > 0.05 kph OR \n ELKS_MaxDev_vx with ELKS_MaxDev_vx = $ELKS_MaxDev_vx kph< 3.0 kph out of condition\n"
	}
    
}


proc ResultWarningIndication3Interventions {args} {

	set DepartureSideNo [NamedValue get DepartureSideNo]    
	set ELKS_On [get ELKS.On]
	set CDCF_visual_warn_ac_time_interv_2 [get CDCF_visual_warn_ac_time_interv_2]
	set CDCF_visual_warn_ac_time_interv_3 [get CDCF_visual_warn_ac_time_interv_3]
	set CDCF_acoustic_warn_ac_time_interv_1 [get CDCF_acoustic_warn_ac_time_interv_1]
	set CDCF_acoustic_warn_ac_time_interv_2 [get CDCF_acoustic_warn_ac_time_interv_2]
	set CDCF_acoustic_warn_ac_time_interv_3 [get CDCF_acoustic_warn_ac_time_interv_3]

	
    Log "##### CDCF: Warning Indication 3 Interventions #####\n"

    if {$ELKS_On >= 1 && $CDCF_visual_warn_ac_time_interv_2 >= 1 && $CDCF_visual_warn_ac_time_interv_3 >= 1 && $CDCF_acoustic_warn_ac_time_interv_1 >= 1 && $CDCF_acoustic_warn_ac_time_interv_2 >= 1 && $CDCF_acoustic_warn_ac_time_interv_3 >= [expr {($CDCF_acoustic_warn_ac_time_interv_2 + 10)}]} {
	Log  "Testrun Warning Indication 3 Interventions with:\n DepartureSideNo:$DepartureSideNo\n  without errors \n" 
    } elseif {$ELKS_On <= 0} {
	Log  "Testrun Warning Indication 3 Interventions with:\n DepartureSideNo:$DepartureSideNo\n  with error: ELKS not run\n"
	} elseif {$CDCF_visual_warn_ac_time_interv_2 < 1 || $CDCF_visual_warn_ac_time_interv_3 < 1 || $CDCF_acoustic_warn_ac_time_interv_1 < 1 || $CDCF_acoustic_warn_ac_time_interv_2 < 1 || $CDCF_acoustic_warn_ac_time_interv_3 < [expr {($CDCF_acoustic_warn_ac_time_interv_2 + 10)}]} {
	Log  "Testrun Warning Indication 3 Interventions with:\n DepartureSideNo:$DepartureSideNo\n  with error:\n CDCF_visual_warn_ac_time_interv_2 with CDCF_visual_warn_ac_time_interv_2=$CDCF_visual_warn_ac_time_interv_2 < 1\n CDCF_visual_warn_ac_time_interv_3 with CDCF_visual_warn_ac_time_interv_3=$CDCF_visual_warn_ac_time_interv_3 < 1\n CDCF_acoustic_warn_ac_time_interv_1 with CDCF_acoustic_warn_ac_time_interv_1=$CDCF_acoustic_warn_ac_time_interv_1 < 1\n CDCF_acoustic_warn_ac_time_interv_2 with CDCF_acoustic_warn_ac_time_interv_2=$CDCF_acoustic_warn_ac_time_interv_2 < 1\n with CDCF_acoustic_warn_ac_time_interv_2=$CDCF_acoustic_warn_ac_time_interv_3 < [expr {($CDCF_acoustic_warn_ac_time_interv_2 + 10)}]\n"
	} 
}


proc ResultWarningIndication10s {args} {

	set DepartureSideNo [NamedValue get DepartureSideNo]
    set ELKS_On [get ELKS.On]
	set CDCF_acoustic_warn_ac [get CDCF_acoustic_warn_ac]
	set CDCF_acoustic_warn_ac_time [get CDCF_acoustic_warn_ac_time]

	
    Log "##### CDCF: Warning Indication 10 seconds #####\n"

    if {$ELKS_On == 1 && $CDCF_acoustic_warn_ac >= 1 && $CDCF_acoustic_warn_ac_time >= 10} {
	Log  "Testrun  Indication 10 seconds with:\n DepartureSideNo:$DepartureSideNo\n  without errors \n"  
    } elseif {$CDCF_acoustic_warn_ac < 1 || $CDCF_acoustic_warn_ac_time < 10} {
	Log  "Testrun Warning Indication 10 seconds with:\n DepartureSideNo:$DepartureSideNo\n  with error: \n acoustic warn signal not activated CDCF_acoustic_warn_ac= $CDCF_acoustic_warn_ac <= 1 OR \n the warning indication time was activated too late: CDCF_acoustic_warn_ac_time= $CDCF_acoustic_warn_ac_time < 10\n "  
    } elseif {$ELKS_On != 1} {
	Log  "Testrun Warning Indication 10 seconds with:\n DepartureSideNo:$DepartureSideNo\n with error: ELKS not activated\n"  
	}
}



proc ResultSteeringOverride {args} {

	set DepartureSideNo [NamedValue get DepartureSideNo]
    set ELKS_On [get ELKS.On]
	set ELKS_deactivate [get ELKS_deactivate]
	set Steer_override_trq [get Steer_override_trq]
	set Avg_Steer_trq_support_ELKS [get Avg_Steer_trq_support_ELKS]
	set ELKS_deactivation_steer_whl_ang [get ELKS_deactivation_steer_whl_ang]
		
    Log "##### CDCF: Steering Override #####\n"

    if {$ELKS_On == 1 && $ELKS_deactivate >= 1 && $Steer_override_trq <= 50 && $Avg_Steer_trq_support_ELKS > 0} {
	Log  "Testrun Steering Override with:\n DepartureSideNo:$DepartureSideNo\n  without errors \n"
    } elseif {$ELKS_On != 1 } {
	Log  "Testrun Steering Overridewith:\n DepartureSideNo:$DepartureSideNo\n with error: ELKS not activated\n"  
    } elseif {$ELKS_deactivate != 1 } {
	Log  "Testrun Steering Overridewith:\n DepartureSideNo:$DepartureSideNo\n with error: ELKS was not deactivated during steering intervention of the driver\n"
	} elseif {$Steer_override_trq > 50 || $Avg_Steer_trq_support_ELKS <= 0 } {
	Log  "Testrun Steering Overridewith:\n DepartureSideNo:$DepartureSideNo\n with error: Steering override trq to big Steer_override_trq = $Steer_override_trq > 50 OR \n the steer support loss of significant steering Avg_Steer_trq_support_ELKS=$Avg_Steer_trq_support_ELKS <= 0"
	}
}



proc ResultLaneKeep {args} {

	set DepartureSideNo [NamedValue get DepartureSideNo]
	set LateralVelocity [NamedValue get LateralVelocity]
	set ELKS_On [get ELKS.On]
	set ELKS_DTLE_CDCF [get ELKS.DTLE_CDCF]
	set ELKS_MaxDev_vx [get ELKS.MaxDev_vx]
	set ELKS_MaxDev_vlat [get ELKS.MaxDev_vlat]
	
    Log "##### LDW: MIXED LANE DEPATURE SIDE #####\n"

    if {$ELKS_On == 1 && $ELKS_DTLE_CDCF >= $::TS::ELKS_DTLE_CDCF && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 1.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n without errors \n" 
    }  elseif {$ELKS_On == 1 && $ELKS_DTLE_CDCF < $::TS::ELKS_DTLE_CDCF && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 1.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n with error: MAXIMUM DTLE EXCEEDEDED with ELKS_DTLE_CDCF = $ELKS_DTLE_CDCF m > $::TS::ELKS_DTLE_CDCF m\n" 
    } elseif {$ELKS_On != 1 && $ELKS_DTLE_CDCF >= $::TS::ELKS_DTLE_CDCF && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 1.0} {
	Log  "Testrun Mixed Lane Depature Side with: \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph  \n with error: ELKS not activated \n"  
    } elseif {$ELKS_On != 1 && $ELKS_DTLE_CDCF < $::TS::ELKS_DTLE_CDCF && $ELKS_MaxDev_vlat <= 0.05 && $ELKS_MaxDev_vx < 1.0} {
	Log  "Testrun Mixed Lane Depature Side with:\n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph \n with error: ELKS not activated and MAXIMUM DTLE EXCEEDEDED\n"  
    } elseif {$ELKS_On == 1 && $ELKS_DTLE_CDCF >= $::TS::ELKS_DTLE_CDCF || $ELKS_MaxDev_vlat > 0.05 || $ELKS_MaxDev_vx > 1.0} {
	Log  "Testrun Mixed Lane Depature Side with: \n DepartureSideNo:$DepartureSideNo \n LateralVelocity:$LateralVelocity kph \n with error:\n ELKS_MaxDev_vlat with ELKS_MaxDev_vlat = $ELKS_MaxDev_vlat kph > 0.05 kph OR \n ELKS_MaxDev_vx with ELKS_MaxDev_vx = $ELKS_MaxDev_vx kph > 3.0 kph out of condition\n"
	}
}



### CheckDTLE_LDW ###
#
# Evaluate Distance to line edge for LDW
#
###
proc CheckDTLE_LDW {args} {
	if {[get ELKS.DTLE_LDW] >= $::TS::ELKS_DTLE_LDW} {
		set result 1
	} else {
		set result -1
	}
	
	set ::TS::CheckDTLE_LDW $result
	::TestMgr::SetCharacteristicValue $result
}

### CheckDTLE_CDCF ###
#
# Evaluate Distance to line edge for LDW
#
###
proc CheckDTLE_CDCF {args} {
	if {[get ELKS.DTLE_CDCF] >= $::TS::ELKS_DTLE_CDCF} {
		set result 1
	} else {
		set result -1
	}
	
	set ::TS::CheckDTLE_CDCF $result
	::TestMgr::SetCharacteristicValue $result
}


### GetLatDev ###
#
# Determine lateral deviation
#
###
proc GetLatDev {Radius} {
	set LateralDeviation 0
	if {$Radius == 1200} {
		switch [NamedValue get LateralVelocity] {
			0.2 {set LateralDeviation 0.06}
			0.3 {set LateralDeviation 0.14}
			0.4 {set LateralDeviation 0.24}
			0.5 {set LateralDeviation 0.38}
			0.6 {set LateralDeviation 0.54}
		}
	} else {
		switch [NamedValue get LateralVelocity] {
			0.5 {set LateralDeviation 0.25}
			0.6 {set LateralDeviation 0.36}
			0.7 {set LateralDeviation 0.49}
		}
	}
	return $LateralDeviation
}


### GetLatDist ###
#
# Determine lateral distance
#
###
proc GetLatDist {Radius} {
	set LateralDistance 0
	if {$Radius == 1200} {
		switch [NamedValue get LateralVelocity] {
			0.2 {set LateralDistance 0.70}
			0.3 {set LateralDistance 0.90}
			0.4 {set LateralDistance 0.80}
			0.5 {set LateralDistance 0.75}
			0.6 {set LateralDistance 0.60}
		}
	} else {
		switch [NamedValue get LateralVelocity] {
			0.5 {set LateralDistance 0.75}
			0.6 {set LateralDistance 0.60}
			0.7 {set LateralDistance 0.53}
		}
	}
	return $LateralDistance
}

### GetLatDist ###
#
# Determine yaw angle
#
###
proc GetYawAngle {args} {
### Angle in rad
	switch [NamedValue get LateralVelocity] {
		0.2 {set YawAngle 0.01}
		0.3 {set YawAngle 0.015}
		0.4 {set YawAngle 0.02}
		0.5 {set YawAngle 0.025}
		0.6 {set YawAngle 0.03}
		0.7 {set YawAngle 0.035}
	}
	return $YawAngle
}


### End Namespace EuroNCAP ###
}