proc TestWare::AddTestItem {} {

variable Gui
variable Test
set item [$Gui(ConfTree) item create -open no -parent 0 -button auto]
set name [dict getstr $Test(Data) Test $Test(Number) Name]
dict set Test(Data) Item $item Key [list Test $Test(Number)]
dict set Test(Data) Key [list Test $Test(Number)] Item $item
$Gui(ConfTree) item style set $item 0 sTestRun 1 sIndex
$Gui(ConfTree) item element configure $item 0 eTextBold -text $name
$Gui(ConfTree) item element configure $item 1 eText -text $item
array set first {
par	1
char	1
crit	1
}
set PData [dict getstr $Test(Data) Test $Test(Number) Param]
foreach idx [dict keys $PData *] {
if {$first(par)} {
set nVars [dict get $Test(Data) Test $Test(Number) nVars]
set item2 [$Gui(ConfTree) item create -open yes -parent $item -button yes]
$Gui(ConfTree) item style set $item2 0 sVariationParent 1 sIndex
$Gui(ConfTree) item element configure $item2 0  eTextItalic -text [l "Parameters:" "Parameter:"] +  eTextItalic2 -text [l "# Variations:" "# Variationen:"]
$Gui(ConfTree) item element configure $item2 1 eText -text $item2
UpdateNVars $Test(Number) $nVars
}
set item3 [$Gui(ConfTree) item create -open no -parent $item2 -button auto]
set name [dict get $PData $idx Name]
$Gui(ConfTree) item style set $item3 0 sVariation 1 sIndex
$Gui(ConfTree) item element configure $item3 0 eText -text $name
$Gui(ConfTree) item element configure $item3 1 eText -text $item3
dict set Test(Data) Item $item3 Key [list Test $Test(Number) Param $idx]
dict set Test(Data) Key [list Test $Test(Number) Param $idx] Item $item3
if {$first(par)} {
dict set Test(Data) Item $item2 Key [list Test $Test(Number) Param $idx]
set first(par) 0
}
}
set Data [dict getstr $Test(Data) Test $Test(Number)]
set item2 ""
set nchars 0
foreach idx [dict keys $Data *] {
if {![dict exists $Data $idx Kind]} continue
if {[dict get $Data $idx Kind] eq "Characteristic"} {
if {$first(char)} {
set item2 [$Gui(ConfTree) item create -open yes -parent $item -button yes]
$Gui(ConfTree) item style set $item2 0 sCharacteristicParent 1 sIndex
$Gui(ConfTree) item element configure $item2 0  eTextItalic -text [l "Characteristics:" "Kennwerte:"] +  eTextItalic2 -text [l "# Characteristics:" "# Kennwerte:"] +  eTextBold2 -text 0
$Gui(ConfTree) item element configure $item2 1 eText -text $item2

set characteristics [list]

}
set item3 [$Gui(ConfTree) item create -open no -parent $item2 -button auto]
set name [dict get $Data $idx Name]
incr nchars

if {[lsearch $characteristics $name] < 0} {

$Gui(ConfTree) item style set $item3 0 sCharacteristic 1 sIndex
$Gui(ConfTree) item element configure $item3 0 eText -text $name
$Gui(ConfTree) item element configure $item3 1 eText -text $item3

lappend characteristics $name 

}
dict set Test(Data) Item $item3 Key [list Test $Test(Number) $idx]
dict set Test(Data) Key [list Test $Test(Number) $idx] Item $item3
if {$first(char)} {
dict set Test(Data) Item $item2 Key [list Test $Test(Number) $idx]
set first(char) 0
}
}
}
if {$item2 != ""} {
$Gui(ConfTree) item element configure $item2 0 eTextBold2 -text $nchars
}
set ncrits 0
foreach idx [dict keys $Data *] {
if {![dict exists $Data $idx Kind]} continue
if {[dict get $Data $idx Kind] eq "Criterion"} {
if {$first(crit)} {
set item2 [$Gui(ConfTree) item create -open yes -parent $item -button yes]
$Gui(ConfTree) item style set $item2 0 sCriterionParent 1 sIndex
$Gui(ConfTree) item element configure $item2 0  eTextItalic -text [l "Criteria:" "Kriterien:"] +  eTextItalic2 -text [l "# Criteria:" "# Kriterien:"] +  eTextBold2 -text 0
$Gui(ConfTree) item element configure $item2 1 eText -text $item2

set criteria [list]
}
set item3 [$Gui(ConfTree) item create -open no -parent $item2 -button auto]
set name [dict get $Data $idx Name]

if {[lsearch $criteria $name] < 0} {

$Gui(ConfTree) item style set $item3 0 sCriterion 1 sIndex
$Gui(ConfTree) item element configure $item3 0 eText -text $name
$Gui(ConfTree) item element configure $item3 1 eText -text $item3

lappend criteria $name
}

dict set Test(Data) Item $item3 Key [list Test $Test(Number) $idx]
dict set Test(Data) Key [list Test $Test(Number) $idx] Item $item3
dict set Test(Data) Test $Test(Number) Crit $ncrits Name $name
dict set Test(Data) Test $Test(Number) Crit $ncrits Selected 0
incr ncrits
if {$first(crit)} {
dict set Test(Data) Item $item2 Key [list Test $Test(Number) $idx]
set first(crit) 0
}
}
}
dict set Test(Data) Test $Test(Number) nCrits $ncrits

}


proc ::TestWare::ChangeCritSelection {item mode} {

variable Test
variable Gui
set key  [Item2Key $item]
set name [dict get $Test(Data) {*}$key Name]
set testNo [Item2TestNo $item]
# set critNo [GetCritNo $testNo $name [lindex $key end]]
set critNo [GetCritNo_2 $testNo $name]

foreach elm $critNo {
	set isSel  [CriterionIsSelected $testNo $elm]
	if {$mode eq "toggle"} {
	set mode [expr {$isSel ? "off" : "on"}]
	}
	if {$mode eq "on" && !$isSel} {
	dict set Test(Data) Test $testNo Crit $elm Selected 1
	$Gui(ConfTree) item state set $item sel
	set inc  1
	} elseif {$mode eq "off" && $isSel} {
	dict set Test(Data) Test $testNo Crit $elm Selected 0
	$Gui(ConfTree) item state set $item !sel
	set inc -1
	} else {
	return
	}
	set critparent [$Gui(ConfTree) item parent $item]
	set testparent [$Gui(ConfTree) item parent $critparent]
	set n [$Gui(ConfTree) item element cget $critparent 0 eTextBold2 -text]
	$Gui(ConfTree) item element configure $critparent 0 eTextBold2 -text [incr n $inc]
	if {$n == 0} {
	$Gui(ConfTree) item state set $testparent !sel
	dict set Test(Data) Test $testNo Selected 0
	} else {
	$Gui(ConfTree) item state set $testparent sel
	dict set Test(Data) Test $testNo Selected 1
	}
}
}


proc ::TestWare::GetCritNo_2 {testNo name} {

variable Test

set Data [dict getstr $Test(Data) Test $testNo Crit]
set tmp [list]

foreach key [dict keys $Data] {
if {[string trim [dict getstr $Data $key Name]] eq [string trim $name]} {
lappend tmp $key
}
}
return $tmp
}

proc ::Load_Extension {args} {
	puts "Reading CarMaker GUI extension 'CMext-TestConfigurator.tcl'"
}

trace add execution ::Project::CheckProject enter ::Load_Extension
rename ::Load_Extension ""
trace remove execution ::Project::CheckProject enter ::Load_Extension